// Module Author: Biju G.C. 2003.0921
// License: The Mozilla Public License ( http://www.mozilla.org/MPL/ )
// Alternate License: GPL (The all time latest at http://www.gnu.org/copyleft/gpl.html ) 
// Homepage: http://links.mozdev.org/

var WebLinks;  //Declare

// Define WebLinks object for Macro Editor
// Author: Biju G.C. 2003.0721

WebLinks = function () 
{

    var PrefObj = Components.classes["@mozilla.org/preferences-service;1"]
                            .getService(Components.interfaces.nsIPrefService);
    var WebLinksPref = PrefObj.getBranch('weblinks.');
    var e;
    var C = {
      LASTUSERID : 'lastuserid',
      DEFAULTUSER : 'weblinks',
      GUESTUSER : 'guest',
      ITEM : 'menuitem',
      POPUP : 'menupopup',
      MENU : 'menu',
      PREFIX : 'weblinks.item.',
      URLGETLINKS :'http://links.mozdev.org/weblinks/getlinks.html',
      URLGETSHARED :'http://links.mozdev.org/weblinks/getshared.html',
      URLGO :'http://links.mozdev.org/go/'
    };
    var userid=C.DEFAULTUSER;
    var challenge =  "guest";

    WebLinks = new Function();
    WebLinks.prototype.New = function(){return new this.constructor()};
    function getlastuserid(){
      try{ 
        if(WebLinksPref.prefHasUserValue(C.LASTUSERID)){
          userid = WebLinksPref.getCharPref(C.LASTUSERID); 
        }
      }catch(e){}
      return userid;
    }
    function setlastuserid(){
      userid=userid.replace(/^\s*/,'').replace(/\s*$/,'');
      try{ 
        if(userid && userid!=C.DEFAULTUSER && userid!=C.GUESTUSER ){
          WebLinksPref.setCharPref(C.LASTUSERID,userid); 
        }
      }catch(e){}
    }


    function askbeforego(a) {
      var msg;
      ok2go = true;
      if (a.search(/:/) > -1) {      
        ok2go = false;
        var p = a.replace(/:.*/, "").toLowerCase();
        switch (p) {
          case "http":
          case "https":
          case "ftp":
          case "ftps":
          case "about":
            ok2go = true;
            break;
          case "mailto":
            ok2go = confirm("Do you want to open e-mail client");
            break;
          case "nntp":
            ok2go = confirm("Do you want to open news client");
            break;
          case "javascript":
            msg = "This link is a Javascript\n";
            msg += "Can Affect: Current page, its forms and sites cookie\n";
            msg += "\n\nDo you want to continue?";
            ok2go = confirm(msg);
            break;
          case "mozmacro":
            msg = "This link is a Macro !!!\n";
            msg += "Can Affect: Complete System\n";
            msg += "Only run, if you trust author of this DEMO\n";
            msg += "\n\nDo you want to continue?";
            ok2go = confirm(msg);
            msg = "Can not run Macro!!!\n";
            msg += "Due to security reason " 
            msg += "Macro Facility is not enabled in this version.\n"
            msg += "When we enable this feature there will "
            msg += "be a change in previous conformation message."

            ok2go && alert(msg);
            ok2go = false;
            break;
          default:
            msg = "Unknow protocol " + p;
            msg += "\nLink " + a.substr(0, 50);
            msg += "\n\nDo you want to continue?";
            ok2go = confirm(msg);
        }
      }
      return (ok2go);
    }

    WebLinks.prototype.dourl = function (thisitem,thisevent,thiscaller) {
      var d=thisitem.getAttribute('data');
      if(!d) return;
      d=unescape(d);
      if(askbeforego(d)) {
        window._content.document.location=d;
      }
    }

    WebLinks.prototype.load = function () {
      var ele4, ele5;
      getlastuserid();
      userid = prompt("Enter UserDir ID\n(to see Demo enter 'guest' or 'weblinks')", userid);
      setlastuserid();
      //challenge = prompt("Enter Challenge Word\n(for Demo enter 'guest')", challenge);
      userid = escape(userid);
      challenge = escape(challenge);
      
      var weblinksitems=httppost(C.URLGETLINKS,
                     "userid=" + userid) // + "&challenge=" + challenge)
                     .responseText;
      weblinksitems = weblinksitems.replace(/\s*$/,'').replace(/^\s*/,'').split("\n");

      if(weblinksitems[0].substr(0,2)!="++") {
        alert(weblinksitems[0].substr(4));
        return;
      }
      ele4 = document.getElementById("weblinks.item._main.menupopup");
      while (ele4.childNodes.length > 4) {
        ele4.removeChild(ele4.lastChild);
      }

      var i,a;
      var head = /\|.*/;
      var nonhead = /[^|]*\|?/;
 
      for (i = 1; i < weblinksitems.length; i++) {
        a = splitweblink(weblinksitems[i],head,nonhead);
        if (a[0]) {
          ele5 = getItem(a[0]);
          ele5.setAttribute("label", a[2]);
          a[4] &&  ele5.setAttribute("data", escape(a[4]));
        }
      }
    }


    function splitweblink(weblink, head,nonhead) {
      var a=[];
      var l=weblink;
      
      a.push(l.replace(head,''));
      l  = l.replace(nonhead,'');

      a.push(l.replace(head,''));
      l  = l.replace(nonhead,'');

      a.push(l.replace(head,''));
      l  = l.replace(nonhead,'');

      a.push(l.replace(head,''));

      a.push(l.replace(nonhead,''));

      a[0]=a[0].replace(/^\s*/,'').replace(/\s*$/,'').replace(/\//g, ".");
      a[1]=a[1].replace(/^\s*/,'').replace(/\s*$/,'');
      a[2]=a[2].replace(/^\s*/,'').replace(/\s*$/,'');
      a[2] || (a[2] = a[0].replace(/.*\./,''));
      a[3]=a[3].replace(/^\s*/,'').replace(/\s*$/,'');
      a[4]=a[4].replace(/^\s*/,'').replace(/\s*$/,'');
       
      return a;
    }


    function getItem(thispath, sfix) {
        var  obj, itemid;
        sfix || (sfix = C.ITEM);
        itemid = C.PREFIX + thispath + "." + sfix;
        obj = document.getElementById(itemid);
        if (obj) {
            return obj;
        }
        var parentpath = thispath.replace(/\.\w*$/, "");
        (parentpath == thispath) && (parentpath = "_main");
        if (sfix == C.ITEM) {
            return newItem(C.ITEM, getItem(parentpath, C.POPUP), itemid);
        }
        var menuid = C.PREFIX + thispath + "." + C.ITEM;
        var menu;
        var menulabel;
        var nobj, pobj;
        obj = document.getElementById(menuid);
        if (obj) {
            menulabel = obj.getAttribute("label");
            pobj = obj.parentNode;
            nobj = obj.nextSibling 
            pobj.removeChild(obj);
            menu = newItem(C.MENU, pobj, menuid,nobj);
            menu.setAttribute("label", menulabel);
            return newItem(C.POPUP, menu, itemid);
        } else {
            menu = newItem(C.MENU, getItem(parentpath, C.POPUP), menuid);
            return newItem(C.POPUP, menu, itemid);
        }
    }

 
    function newItem(itemtype, parent, itemid, nextsib) {
        var a = document.createElement(itemtype);
        itemid && (a.id = itemid);
        //parent && parent.appendChild(a);
        parent && parent.insertBefore(a,nextsib);
        return a;
    }

    function httppost(url,data) {
      var p = new XMLHttpRequest();
       
      p.open("POST", url, false);
      p.setRequestHeader("Content-type", "application/x-www-form-urlencoded");
      p.send(data);
      return p;
    }


    WebLinks.prototype.createSublinks = function (thispopup) {
      var i;
      var children=thispopup.childNodes;  
      var data;
      var urlgo=C.URLGO;
      for (i=0;i< children.length;i++ ) {
         data=unescape(''+children[i].getAttribute("data"));
         if(data.toLowerCase().indexOf(urlgo)==0){
          transformGoMenu(children[i],thispopup,data);
         }
      }

    }


    function transformGoMenu(thisitem, parentpopup, data) {
      var label = thisitem.getAttribute("label");
      var data2= data.substr(C.URLGO.length).toLowerCase().replace(/\/$/,"");
      // check for at least usrid, and invalid character 
      // double slash(/) and should not start with a slash
      if(!data2 || data2.search(/\/\//)!=-1 
         || data2.search(/^\//)!=-1 
         || data2.search(/[^a-z0-9\/]/)!=-1  ){
        //invalid userid so blank the url
        thisitem.setAttribute("label",'Err!!! '+label);
        thisitem.setAttribute("data",'');
        return;
      }

      var shareid = data2.replace(/\/.*/,'');
      var weblinksitems=httppost(C.URLGETSHARED,
                     "shareid=" + shareid )
                     .responseText.replace(/\s*$/,'').replace(/^\s*/,'');
         //+ "&url=" + escape(data)
      if(weblinksitems.substr(0,2)!="++") {
        return;
      }

     // weblinksitems = weblinksitems.replace(/^\s*\/*/mg,"").replace(/\s*$/mg,"");
      weblinksitems = weblinksitems.split('\n');

      var a=[];
      var thispath = thisitem.id.substr(C.PREFIX.length)
                     .slice(0,-1 - C.ITEM.length).replace(/\./g,"/");

      var data3 = data2.replace(/[^\/]*\/?/,'');
      var ex  = RegExp( data3 +"\\/?\\s*\\|?");
      var dlen =data3.length;
      var i;
      dlen || (thispath +='/');
      for (i = 1; i < weblinksitems.length; i++) {

        if(weblinksitems[i].search(ex) != -1) {
          a.push(thispath+weblinksitems[i].substr(dlen));
        }
      }
     // alert(thispath+'\n'+a.join('\n'))
      weblinksitems=a;
      if(!weblinksitems.length ) {
        thisitem.setAttribute("data",'' );        
        return;
      }

      var head = /\|.*/;
      var nonhead = /[^|]*\|?/;

      if(weblinksitems.length == 1 ) {
        a=splitweblink(weblinksitems[0],head,nonhead)
        thisitem.setAttribute("data", a[3] );        
        return;
      }
      var thislabel=thisitem.getAttribute("label");
      var thisid=thisitem.id;

      for (i = 0; i < weblinksitems.length; i++) {
        a = splitweblink(weblinksitems[i],head,nonhead);
        if (a[0]) {
          ele5 = getItem(a[0]);
          ele5.setAttribute("label", a[2]);
          a[4] &&  ele5.setAttribute("data", escape(a[4]));
        }
      }

     document.getElementById(thisid).setAttribute("label",thislabel);

    }


  QuickTools= WebLinks;
  // Menu event method to install a theme from URL 
  // Author: Biju G.C. 2003.0625
  QuickTools.prototype.installFromURLTheme = function (mode, menu)
  {
    var filename = prompt(getPrompt (menu, 'Enter Theme Location/URL'));
    if (filename) installThemeNow(tofullurl(filename));
  }


  // Menu event method to install a extension from URL 
  // Author: Biju G.C. 2003.0625
  QuickTools.prototype.installFromURLExt = function (mode, menu)
  {
    var filename = prompt(getPrompt (menu, 'Enter Extention Location/URL'));
    if (filename) triggerURL(tofullurl(filename));
  }

  // gets prompt attribute from an object 
  // Author: Biju G.C. 2003.0625
  function getPrompt (thisobject, defaultval)
  {
   if(thisobject && thisobject.getAttribute && thisobject.getAttribute("prompt")) 
     return thisobject.getAttribute("prompt");
   else
     return defaultval;
  }

  // Credits to mozdev.org, following function copied from
  // http://mozdev.org
  // Author: unknown
  function triggerURL(url) 
  {
    if (!InstallTrigger.updateEnabled()) return false; 
    else InstallTrigger.startSoftwareUpdate(url); 
  }


  // Credits to David Tenser. & texturizer.net, following 2 function copied
  // from http://texturizer.net/firebird/extensionSetup.js then modified

  // Author: texturizer.net
  function doneFn(name,result) {}

  // Author: texturizer.net
  function doXPIInstall(file,name)
  {
    var xpi = new Object();
    xpi[name] = file;
    InstallTrigger.install(xpi,doneFn);
  }


  // Functions needed for JAR install
  // Author: Alan Starr 20021210
  function installTheme(where)
  {
    var file = '';
    if (where == 'local') {
      file = 'file:///' + escape(document.getElementById('filename').value.replace(/\\/g,'/'));
    } else {
      file = document.getElementById('url').value;
    }
    InstallTrigger.installChrome(InstallTrigger.SKIN, file, getName(file));
  }

  // Finds the name of the theme from the filename
  // Author: Alan Starr 20021210
  function getName(raw)
  {
    var grabFileStart = raw.lastIndexOf('/');
    var grabFileEnd = raw.lastIndexOf('.');
    if (grabFileStart >= grabFileEnd) {
      return 'Invalid file name';
    } else {
      return raw.substring(grabFileStart + 1,grabFileEnd);
    }
  }

  // Author: Alan Starr 20021210
  function installThemeNow(file)
  {
    // used in the hrefs 
    var extStart = file.lastIndexOf('.');
    var fileType = file.substring(extStart, file.length).toLowerCase();
    if (fileType == 'xpi') {
      doXPIInstall(file, getName(file));
    } else {
      InstallTrigger.installChrome(InstallTrigger.SKIN, file, getName(file));
    }
    return true;
  }

  // Author: Biju G. C. 2003.0925
  function tofullurl(url,base,search)
  {
    base || (base='file:///');

    url=url.replace(/^\s*/,'')
           .replace(/\s*$/,'');
    var u = url.toLowerCase();
      
    var noturl=(u.search(/^[hf]tt?ps?:\/\//)
              + u.search(/^file:\/\//))==-2;
    noturl && (url=base+escape(url.replace(/\\/g,'/')).replace(/%3A/,':').replace(/%7E/,'~'));
    search && (url+='?'+search);
    return url;
  }

     

  // Actual Create Instance
  WebLinks = new WebLinks();

}

 WebLinks(); // Call to Create Instance

